import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class BlockTransactionService {
  constructor(private http: HttpClient) {}

  getAllRecord(Transactionnumber: any, StatusID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/block-transaction/all-record?G_Agent_ID=0&IsHeadOffice=true&Agent_Branch_ID=0&Transactionnumber=${Transactionnumber}&StatusID=${StatusID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAllRecordByStatus(StatusID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/block-transaction/all-record?G_Agent_ID=0&IsHeadOffice=true&Agent_Branch_ID=1001&StatusID=${StatusID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  View(Transactionnumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/block-transaction/view?Transactionnumber=${Transactionnumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  block(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/block-transaction/block`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  unBlock(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/block-transaction/unblock`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
