import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class CancellationCheckerService {
  constructor(private http: HttpClient) {}

  getAllRecord(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/cancellation-checker/all-record`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getLog(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/cancellation-checker/log?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  View(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/cancellation-checker/view?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  approve(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/cancellation-checker/approve`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  reject(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/cancellation-checker/reject`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  Recheck(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/cancellation-checker/recheck`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
