import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ChannelCancelTransactionService {
  constructor(private http: HttpClient) {}

  getDataByDate(frmDate: any, toDate: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/channel-cancel-transaction/all-record-by-date?frmDate=${frmDate}&toDate=${toDate}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDataByTransactionNumber(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/channel-cancel-transaction/all-record-by-transaction-number?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  cancellationStatus(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/channel-cancel-transaction/cancellation-status`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  resend(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/channel-cancel-transaction/send`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
