import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class DownloadTransactionsFileService {
  constructor(private http: HttpClient) {}

  getTransactionDownloadFileList(searchText: any = 0, searchType: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-download-file/all-record?searchText=${searchText}&SearchType=${searchType}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  fileDetails(fileName: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-download-file/file-detail?fileName=${fileName}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  downloadTransaction(countryId: number = 0, bankId: number = 0) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction-management/transaction-download-file/download-file?CountryID=${countryId}&BankID=${bankId}&UserID=1`,
      '',
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
