import { Component, OnInit } from '@angular/core';
import { PaidUnpaidTransactionService } from '../services/paid-unpaid-transaction.service';

@Component({
  selector: 'app-paid-unpaid-transactions',
  templateUrl: './paid-unpaid-transactions.component.html',
  styleUrls: ['./paid-unpaid-transactions.component.css'],
})
export class PaidUnpaidTransactionsComponent implements OnInit {
  agentAccounts: any[] = [];
  branches: any[] = [];
  ccys: any[] = [];
  states: any[] = [];
  selectedAgentAccount: any;
  selectedBranch: any;
  selectedCCY: any;
  selectedState: any;
  startDate: any = new Date(new Date().toLocaleString("en-US", {timeZone: "Asia/Riyadh"})).toISOString().substring(0, 10);
  endDate: any = new Date(new Date().toLocaleString("en-US", {timeZone: "Asia/Riyadh"})).toISOString().substring(0, 10);
  // startDate: any;
  // endDate: any;
  sessionGAgentId: any;

  constructor(
    private paidUnpaidTransactionService: PaidUnpaidTransactionService
  ) {}

  ngOnInit(): void {
    this.loadAgentAccounts();
  }
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  loadAgentAccounts() {
    const agentId =
      this.sessionGAgentId !== undefined ? this.sessionGAgentId : 0;
    this.paidUnpaidTransactionService
      .getTransactionStatusPaidUnpaidReportByAgentAccount(agentId)
      .subscribe((data: any) => {
        this.agentAccounts = data;

        this.onAgentAccountChange(0);
      });
  }

  onAgentAccountChange(selectedAgentAccountId: any) {
    if (selectedAgentAccountId !== undefined) {
      this.selectedAgentAccount = selectedAgentAccountId;

      this.paidUnpaidTransactionService
        .getTransactionStatusPaidUnpaidReportByBranch(selectedAgentAccountId)
        .subscribe((data: any) => {
          this.branches = data;
        });

      this.paidUnpaidTransactionService
        .getTransactionStatusPaidUnpaidReportByCCY(selectedAgentAccountId)
        .subscribe((data: any) => {
          this.ccys = data;
        });

      this.paidUnpaidTransactionService
        .getTransactionStatusReport()
        .subscribe((data: any) => {
          this.states = data;
        });
    }
  }

  onSubmit() {}
}
