import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class RejectedCustomerService {
  constructor(private http: HttpClient) {}

  getCustomer(SearchType: any, FromDate: any, ToDate: any, Search: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/rejected-customer/all-record?SearchType=${SearchType}&FromDate=${FromDate}&ToDate=${ToDate}&Search=${Search}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getNationalityList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/nationality`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getProductTypeList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-edit-customer-registration/product-type?customertype=1`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getOccupationList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/occupation`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSourceList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/source`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getIdTypeList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-edit-customer-registration/id-type?CustomerType=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  Edit(CustomerNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/rejected-customer/edit?CustomerNumber=${CustomerNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
