import { Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RemoveTransactionService } from '../remove-transaction.service';
import { CountryManagementComponent } from '../country-management/country-management.component';
import { getCacheData } from '../utils/helper';
import { AuthService } from '../services/auth.service';

@Component({
  selector: 'app-remove-transaction',
  templateUrl: './remove-transaction.component.html',
  styleUrls: ['./remove-transaction.component.css'],
})
export class RemoveTransactionComponent {
  constructor(
    private RemoveTransactionSvc: RemoveTransactionService,
    private authSvc: AuthService
  ) {}

  public searchByType: any = 1;
  AgentTypeID: any = 0;
  AgentList: any;
  Status: any;
  isLoading: boolean = false;

  ReceiveCurrency: any;
  AgentBranchList: any;
  baseCountries: any[] = [];
  status: any[] = [];
  TransferTypeList: any[] = [];
  payinCountryList: any[] = [];
  CountryID: any = 0;
  Users: any;
  TransferType: any;
  transactionNo: string;
  startDate: string;
  endDate: string;
  customerNameFirst: string;
  customerNameLast: string;
  beneficiaryNameFirst: string;
  beneficiaryNameLast: string;
  AgentType: any;
  ReceiveCountry: any;
  selectReceiveCountry: any;
  AgentID: any;
  selectedTransferType: any;
  data: any[] = [];
  SendCountry: any;
  SendCurrency: any;
  selectedStatus: any;
  selectedAgentBranchId: any;
  selectedSendCurrency: any;
  selectedReceiveCurrency: any;
  selectAll: boolean = false;

  ngOnInit(): void {
    this.getStatus();
    this.getAgentType();
    this.getSendCountry();
    this.getReceiveCountry();
    this.startDate = this.authSvc.getTodayDate();
    this.endDate = this.authSvc.getTodayDate();
  }

  SearchType(event: any) {
    this.searchByType = parseInt(event.target.value, 10);
    console.log('this.searchByType: ', this.searchByType);
  }

  onChangeStatus(event: any) {}

  filterBySearchFields() {}

  filterByTransactionNo() {
    console.log(this.startDate);
    this.isLoading = true;
    const payload = {
      TopRecord: 10,
      SRTRNo: this.transactionNo || '',
      StatusID: this.selectedStatus || 1, // Assuming you want the first or a default
      flag: 1,
      SearchByType: this.searchByType,
      UserGroupType: getCacheData('G_UserGroupType') || 8,
      G_Agent_ID: getCacheData('G_Agent_ID') || 0,
      AgentBranchId: this.selectedAgentBranchId || 0,
      UserID: getCacheData('G_UserID') || 0,
      Agent_ID: this.AgentID || -1,
      Customer_Name_F: '',
      Customer_Name_L: '',
      Beneficiary_Name_F: '',
      Beneficiary_Name_L: '',
      TrTypeID: this.selectedTransferType || -1,
      PayInCountryID: this.CountryID || -1,
      PayInCurrencyID: this.selectedSendCurrency || 0,
      PayOutCountryID: this.selectReceiveCountry || -1,
      PayOutCurrencyID: this.selectedReceiveCurrency || -1,
      StartDate: this.startDate,
      EndDate: this.endDate,
      LoginAgentCountry: getCacheData('G_LoginAgentCountry') || 0,
      LoginAgentCity: getCacheData('G_LoginAgentCity') || 0,
      LoginAgentLocation: getCacheData('G_LoginAgentLocation') || 0,
    };

    this.RemoveTransactionSvc.getAllRecord(payload).subscribe({
      next: (res) => {
        // Check if res is an array before assignment
        this.data = Array.isArray(res) ? res : [];
        console.log('Data received:', this.data);
        this.isLoading = false;
      },
      error: (err) => {
        console.error('Error fetching records:', err);
        this.data = []; // Reset data on error
        this.isLoading = false;
      },
    }); // The misplaced parenthesis was here
  }

  getStatus() {
    this.RemoveTransactionSvc.getStatus().subscribe((res) => {
      this.Status = res;
    });
  }

  getAgentType() {
    this.RemoveTransactionSvc.getAgentType().subscribe((res) => {
      this.AgentType = res;
    });
  }
  onSelectAgentType(AgentTypeID) {
    this.AgentID = AgentTypeID;
    this.getAgent();
  }
  getSendCountry() {
    this.RemoveTransactionSvc.getSendCountry().subscribe((res) => {
      this.SendCountry = res;
    });
  }

  getSendCurrency(CountryId) {
    this.RemoveTransactionSvc.getSendCurrency(CountryId).subscribe((res) => {
      this.SendCurrency = res;
    });
  }

  getAgent() {
    this.RemoveTransactionSvc.getAgent(
      this.AgentTypeID,
      this.CountryID
    ).subscribe((res) => {
      this.AgentList = res;
    });
  }

  getAgentBranch(AgentID) {
    this.RemoveTransactionSvc.getAgentBranch(AgentID).subscribe((res) => {
      this.AgentBranchList = res;
    });
  }

  onSelectAgent(AgentID) {
    this.AgentID = AgentID;
    this.getAgentBranch(AgentID);
    this.getTransferType();
  }

  onSelectAgentBranch(AgentBranchID) {
    this.selectedAgentBranchId = AgentBranchID;
    this.getUser(AgentBranchID);
  }

  getUser(AgentBranchID) {
    this.RemoveTransactionSvc.getUser(AgentBranchID, this.AgentID).subscribe(
      (res) => {
        this.Users = res;
      }
    );
  }

  getTransferType(GroupID: any = 0) {
    this.RemoveTransactionSvc.getTransferType(GroupID, this.AgentID).subscribe(
      (res) => {
        this.TransferType = res;
      }
    );
  }
  onSelectSendCountry(countryId) {
    this.CountryID = countryId;
    this.getSendCurrency(countryId);
    this.getAgent();
    this.getReceiveCountry();
  }

  getReceiveCountry() {
    this.RemoveTransactionSvc.getReceiveCountry(this.CountryID).subscribe(
      (res) => {
        this.ReceiveCountry = res;
      }
    );
  }

  onSelectReceiveCountry(ReceiveCountryID) {
    console.log(ReceiveCountryID);
    this.selectReceiveCountry = ReceiveCountryID;
    this.getReceiveCurrency(ReceiveCountryID);
  }

  getReceiveCurrency(ReceiveCountryID) {
    this.RemoveTransactionSvc.getReceiveCurrency(ReceiveCountryID).subscribe(
      (res) => {
        this.ReceiveCurrency = res;
      }
    );
  }

  filterByAdvanceSearchFields() {}

  clearCriteria() {}

  editTransaction(transaction: any) {}

  ViewLast(event: any) {}
  searchByTypeChange(event: any): void {}
  filter() {
    console.log('Filter function called');
  }
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  toggleSelectAll() {
    this.data.forEach((d: any) => (d.selected = this.selectAll));
  }

  checkIfAllSelected() {
    this.selectAll = this.data.every((d: any) => d.selected);
  }

  approveSelected() {
    const selectedTransactions = this.data.filter(
      (transaction: any) => transaction.selected
    );
    if (selectedTransactions.length === 0) {
      alert('No transactions selected for approval.');
      return;
    }

    const payload = selectedTransactions.map((transaction: any) => ({
      TransactionNumber: transaction.SRTRNo,
      G_UserID: getCacheData('G_UserID'), // You can replace this with the appropriate value
      IsChk: true,
    }));

    this.RemoveTransactionSvc.approvedTransaction(payload).subscribe({
      next: (response: any) => {
        alert('Selected transactions have been approved.');
        this.filterByTransactionNo();
      },
      error: (error: any) => {
        alert('An error occurred while approving the transactions.');
      },
    });
  }
}
