import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class AgentBalancesService {
  apiUrl = environment.apiUrl;

  constructor(private http: HttpClient) {}

  private getRequestHeaders(): HttpHeaders {
    return new HttpHeaders({
      'Authorization': getCacheData('admin_token'),
      'Accept': 'application/json',
      'username': getCacheData('username')
    });
  }

  getAgentBalancesGrid(countryId: any = 0, agentId: any, fromDate: string, toDate: string) {
    return this.http.get(
      `${this.apiUrl}/api/master/reports/agent-balances-report/grid?CountryID=${countryId}&AgentID=${agentId}&FromDate=${fromDate}&ToDate=${toDate}`,
      { headers: this.getRequestHeaders() }
    );
  }

  getAgentList(countryId: any = 0) {
    return this.http.get(
      `${this.apiUrl}/api/master/reports/agent-balances-report/agent?CountryID=${countryId}`,
      { headers: this.getRequestHeaders() }
    );
  }

  getCountryList(userId: any = 0) {
    return this.http.get(
      `${this.apiUrl}/api/master/reports/agent-balances-report/country?UserID=${userId}`,
      { headers: this.getRequestHeaders() }
    );
  }
}
