import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class EditCustomerRegistrationService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getProductTypeList(customerType = 1) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-edit-customer-registration/product-type?customertype=${customerType}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSearchByCustomerNumber(customerNumber: any = '') {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-edit-customer-registration/search-by-customerno?CustomerNumber=${customerNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getIdTypeList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-edit-customer-registration/id-type?CustomerType=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateCustomerRegistration(payload: any = {}) {
    return this.http.patch(
      `${environment.apiUrl}/api/transaction-management/transaction-edit-customer-registration/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
