import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class GlobalTransactionLimitService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getGlobalTransactionList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/global-trxn-limit-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateSegmentLimit(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/update-segement-limit`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateGlobalLimit(
    payload: any = {},
    transactionLimit: any = '',
    transactionLimitBank: any = ''
  ) {
    return this.http.patch(
      `${environment.apiUrl}/api/master/update-global-trxn-limit?TransactionLimit=${transactionLimit}&TransactionLimit_Bank=${transactionLimitBank}&UserID=1`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
