import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class MarginsSpecificSendingCountryService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getAllSendingCountries(token: any, username, countryId = 0): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/exchange-margin/agency-margin/sending-country?countryId=${countryId}`,
      {
        headers: headers,
      }
    );
  }

  getMarginSendingCountry(token: any, username): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/exchange-margin/agency-margin/sending-country/sending-country-dropdown`,
      {
        headers: headers,
      }
    );
  }

  getMarginSendCountry(token: any, username): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/exchange-margin/agency-margin/sending-country/add/sending-country`,
      {
        headers: headers,
      }
    );
  }

  getMarginSendingCurrency(
    token: any,
    username,
    countryId = 0
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/exchange-margin/agency-margin/sending-country/add/sending-currency?countryID=${countryId}`,
      {
        headers: headers,
      }
    );
  }

  addSpecificSendingCountry(
    token: any,
    username: any,
    payload: any
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.post(
      `${environment.apiUrl}/api/master/exchange-margin/agency-margin/sending-country
      `,
      payload,
      {
        headers: headers,
      }
    );
  }

  updateSpecificSendingCountry(
    token: any,
    username: any,
    payload: any
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.patch(
      `${environment.apiUrl}/api/master/exchange-margin/agency-margin/sending-country`,
      payload,
      {
        headers: headers,
      }
    );
  }
}
