import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root'
})
export class PaidUnpaidTransactionService {
  private baseUrl = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getTransactionStatusPaidUnpaidReportByCCY(agentAccountId: any) {
    const url = `${this.baseUrl}/api/master/reports/txn-status-paid-unpaid-report/ccy?AgentAccountID=${agentAccountId}`;
    return this.http.get(url, this.getRequestOptions());
  }

  getTransactionStatusPaidUnpaidReportByBranch(agentAccountId: any) {
    const url = `${this.baseUrl}/api/master/reports/txn-status-paid-unpaid-report/branch?AgentAccountID=${agentAccountId}`;
    return this.http.get(url, this.getRequestOptions());
  }

  getTransactionStatusPaidUnpaidReportByAgentAccount(sessionGAgentId: any) {
    const url = `${this.baseUrl}/api/master/reports/txn-status-paid-unpaid-report/agent-account?SessionG_Agent_ID=${sessionGAgentId}`;
    return this.http.get(url, this.getRequestOptions());
  }

  getTransactionStatusReport() {
    const url = `${this.baseUrl}/api/master/reports/txn-status-paid-unpaid-report/status`;
    return this.http.get(url, this.getRequestOptions());
  }

  private getRequestOptions() {
    return {
      headers: {
        Authorization: getCacheData('admin_token'),
        Accept: 'application/json',
        username: getCacheData('username'),
      }
    };
  }
}
