import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { environment } from '../../environments/environment';
import { getCacheData } from '../utils/helper';
 
@Injectable({
  providedIn: 'root',
})
export class SendRemittanceService {
  private baseUrl = environment.apiUrl;
 
  constructor(private http: HttpClient) {}
  getAgents(countryId: any) {
    const headers = this.getHeaders();
    return this.http.get(
      `${this.baseUrl}/api/master/reports/Remittance/remittance-send/agent?CountryID=${countryId}`,
      { headers }
    );
  }
 
 
  getAgentBranches(agentId: number) {
    const headers = this.getHeaders();
    return this.http.get(
      `${this.baseUrl}/api/master/reports/Remittance/remittance-send/agent-branch?AgentID=${agentId}`,
      { headers }
    );
  }
  countrySend(CountryType: any) {
    const headers = this.getHeaders();
    return this.http.get(
      `${this.baseUrl}/api/master/reports/Remittance/remittance-send/country?CountryType=${CountryType}`,
      { headers }
    );
  }
 
  getTransferTypes() {
    const headers = this.getHeaders();
    return this.http.get(
      `${this.baseUrl}/api/master/reports/Remittance/remittance-send/transfer-type`,
      { headers }
    );
  }
 
  getStatus() {
    const headers = this.getHeaders();
    return this.http.get(
      `${this.baseUrl}/api/master/reports/Remittance/remittance-send/status`,
      { headers }
    );
  }
 
  getRemittanceGridData(payload: any) {
    const headers = this.getHeaders();
    return this.http.post(
      `${this.baseUrl}/api/master/reports/Remittance/remittance-send/grid?gridRequest=1`,
      payload,
      { headers }
    );
  }
 
  grid(payload: any) {
   
    return this.http.post(
      `${this.baseUrl}/api/master/reports/Remittance/remittance-send/grid
      `,
      payload,
      {
        headers:  {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
 
  private getHeaders(): HttpHeaders {
    return new HttpHeaders({
      Authorization: getCacheData('admin_token'),
      Accept: 'application/json',
      username: getCacheData('username'),
    });
  }
}
 