import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class VatService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getVatInformationList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/vat/vat-information`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateVatInformation(
    userId: any = 0,
    vatAccNumber: any = 0,
    vatPercentage: any = 0
  ) {
    return this.http.patch(
      `${environment.apiUrl}/api/master/vat/update-vat-information?UserID=${userId}&VATAccNumber=${vatAccNumber}&VATPercentage=${vatPercentage}`,
      '',
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
