import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ViewDuplicateTransactionsService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getAllRecord(fromDate: any, toDate: any, transactionNumber: any = '') {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-duplicate/all-record?FromDate=${fromDate}&Todate=${toDate}&TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  releaseTransaction(transactionNo:any, genuineTransactionNo:any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction-management/transaction-duplicate/release?TransactionNo=${transactionNo}&GenuineTransactionNo=${genuineTransactionNo}&UserID=${getCacheData('G_UserID')}`,
      {},
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
