import { Pipe, PipeTransform } from '@angular/core';
import { DatePipe } from '@angular/common';
import * as moment from 'moment';

@Pipe({
  name: 'customDate',
})
export class CustomDatePipe implements PipeTransform {
  constructor(private datePipe: DatePipe) {}

  transform(value: any, format: string): string {
    if (value) {
      const momentDate = moment(value);
      return momentDate.isValid()
        ? momentDate.format(format)
        : this.datePipe.transform(value, format);
    }
    return '';
  }
}
